diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/network/test/test-data-rate.cc ns-3.32/src/network/test/test-data-rate.cc
--- ns-3.31/src/network/test/test-data-rate.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.32/src/network/test/test-data-rate.cc	2020-10-06 15:35:43.000000000 -0700
@@ -0,0 +1,122 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) Facebook, Inc. and its affiliates.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Greg Steinbrecher <grs@fb.com>
+ */
+
+#include "ns3/data-rate.h"
+#include "ns3/log.h"
+#include "ns3/test.h"
+#include "ns3/simulator.h"
+
+using namespace ns3;
+
+class DataRateTestCase : public TestCase
+{
+public:
+  DataRateTestCase (std::string name);
+  virtual ~DataRateTestCase ();
+  void CheckTimesEqual (Time t1, Time t2, const std::string msg);
+
+protected:
+  virtual void DoRun (void) = 0;
+};
+
+DataRateTestCase::DataRateTestCase (std::string name) : TestCase (name)
+{
+}
+
+DataRateTestCase::~DataRateTestCase ()
+{
+}
+
+void
+DataRateTestCase::CheckTimesEqual (Time actual, Time correct, const std::string msg)
+{
+  int64x64_t actualFemtos = actual.GetFemtoSeconds ();
+  int64x64_t correctFemtos = correct.GetFemtoSeconds ();
+  NS_TEST_EXPECT_MSG_EQ (actualFemtos, correctFemtos, msg);
+}
+
+class DataRateTestCase1 : public DataRateTestCase
+{
+public:
+  DataRateTestCase1 ();
+  void SingleTest (std::string rate, size_t nBits, Time correctTime);
+
+private:
+  virtual void DoRun (void);
+};
+
+DataRateTestCase1::DataRateTestCase1 ()
+    : DataRateTestCase ("Test rounding of conversion from DataRate to time")
+{
+}
+
+void
+DataRateTestCase1::SingleTest (std::string rate, size_t nBits, Time correctTime)
+{
+  DataRate dr (rate);
+  Time bitsTime = dr.CalculateBitsTxTime (nBits);
+  CheckTimesEqual (bitsTime, correctTime, "CalculateBitsTxTime returned incorrect value");
+  if ((nBits % 8) == 0)
+    {
+      Time bytesTime = dr.CalculateBytesTxTime (nBits / 8);
+      CheckTimesEqual (bytesTime, correctTime, "CalculateBytesTxTime returned incorrect value");
+    }
+}
+
+void
+DataRateTestCase1::DoRun ()
+{
+  if (Time::GetResolution () != Time::FS)
+    {
+      Time::SetResolution (Time::FS);
+    }
+  SingleTest ("1GB/s", 512, Time (NanoSeconds (64)));
+  SingleTest ("8Gb/s", 512, Time (NanoSeconds (64)));
+  SingleTest ("1Gb/s", 512, Time (NanoSeconds (512)));
+  SingleTest ("8GB/s", 512, Time (NanoSeconds (8)));
+  size_t nBits;
+  for (nBits = 0; nBits <= 512; nBits++)
+    {
+      SingleTest ("1Mb/s", nBits, Time (MicroSeconds (nBits)));
+      SingleTest ("10Mb/s", nBits, Time (NanoSeconds (nBits * 100)));
+      SingleTest ("100Mb/s", nBits, Time (NanoSeconds (nBits * 10)));
+      SingleTest ("1Gb/s", nBits, Time (NanoSeconds (nBits)));
+      SingleTest ("10Gb/s", nBits, Time (PicoSeconds (nBits * 100)));
+      SingleTest ("25Gb/s", nBits, Time (PicoSeconds (nBits * 40)));
+      SingleTest ("40Gb/s", nBits, Time (PicoSeconds (nBits * 25)));
+      SingleTest ("100Gb/s", nBits, Time (PicoSeconds (nBits * 10)));
+      SingleTest ("200Gb/s", nBits, Time (PicoSeconds (nBits * 5)));
+      SingleTest ("400Gb/s", nBits, Time (FemtoSeconds (nBits * 2500)));
+    }
+}
+
+class DataRateTestSuite : public TestSuite
+{
+public:
+  DataRateTestSuite ();
+};
+
+DataRateTestSuite::DataRateTestSuite () : TestSuite ("data-rate", UNIT)
+{
+  AddTestCase (new DataRateTestCase1 (), TestCase::QUICK);
+}
+
+// Do not forget to allocate an instance of this TestSuite
+static DataRateTestSuite sDataRateTestSuite;
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/network/utils/data-rate.cc ns-3.32/src/network/utils/data-rate.cc
--- ns-3.31/src/network/utils/data-rate.cc	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/network/utils/data-rate.cc	2020-10-06 15:35:43.000000000 -0700
@@ -24,7 +24,7 @@
 #include "ns3/log.h"
 
 namespace ns3 {
-  
+
 NS_LOG_COMPONENT_DEFINE ("DataRate");
 
 ATTRIBUTE_HELPER_CPP (DataRate);
@@ -229,15 +229,13 @@
 Time DataRate::CalculateBytesTxTime (uint32_t bytes) const
 {
   NS_LOG_FUNCTION (this << bytes);
-  // \todo avoid to use double (if possible).
-  return Seconds (static_cast<double>(bytes)*8/m_bps);
+  return Seconds (bytes * 8) / m_bps;
 }
 
 Time DataRate::CalculateBitsTxTime (uint32_t bits) const
 {
   NS_LOG_FUNCTION (this << bits);
-  // \todo avoid to use double (if possible).
-  return Seconds (static_cast<double>(bits)/m_bps);
+  return Seconds (bits) / m_bps;
 }
 
 uint64_t DataRate::GetBitRate () const
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/network/utils/data-rate.h ns-3.32/src/network/utils/data-rate.h
--- ns-3.31/src/network/utils/data-rate.h	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/network/utils/data-rate.h	2020-10-06 15:35:43.000000000 -0700
@@ -248,6 +248,19 @@
  */
 double operator* (const Time& lhs, const DataRate& rhs);
 
+namespace TracedValueCallback {
+
+/**
+ * \ingroup network
+ * TracedValue callback signature for DataRate
+ *
+ * \param [in] oldValue original value of the traced variable
+ * \param [in] newValue new value of the traced variable
+ */
+typedef void (* DataRate)(DataRate oldValue,
+                          DataRate newValue);
+
+}  // namespace TracedValueCallback
 
 } // namespace ns3
 
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/network/utils/lollipop-counter.h ns-3.32/src/network/utils/lollipop-counter.h
--- ns-3.31/src/network/utils/lollipop-counter.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.32/src/network/utils/lollipop-counter.h	2020-10-06 15:35:43.000000000 -0700
@@ -0,0 +1,404 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2020 Universita' di Firenze, Italy
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Tommaso Pecorella <tommaso.pecorella@unifi.it>
+ */
+
+
+#ifndef LOLLIPOP_COUNTER_H
+#define LOLLIPOP_COUNTER_H
+
+#include <limits>
+#include "ns3/abort.h"
+
+namespace ns3 {
+
+/**
+ * \ingroup seq-counters
+ * \class LollipopCounter
+ *
+ * \brief Template class implementing a Lollipop counter as defined in \RFC{8505}, \RFC{6550}, and [Perlman83].
+ *
+ * A Lollipop counter is a counter that solves initialization and
+ * out-of-order problems often occurring in Internet protocols.
+ *
+ * The counter is split in two regions, an initializing region, and a circular region, having the same size.
+ * Assuming a counter using an uint8_t (max value 255), values from 128 and greater
+ * are used as a linear sequence to indicate a restart and bootstrap the counter, and the values less
+ * than or equal to 127 are used as a circular sequence number space of
+ * size 128 as mentioned in \RFC{1982}.
+ *
+ * In both regions, the comparison between two counters is allowed only if both counters are inside a
+ * Sequence Window. The default value for the Sequence Window is equal to 2^N where N is half the number
+ * of digits of the underlying type. For an uint8_t the Sequence Window is 16.
+ *
+ * The counter, by default, is initialized to the maximum counter value minus the Sequence Window plus one, e.g.,
+ * in case of a uint8_t, to 240.
+ *
+ * This implementation extends the case presented in RFCs, allowing to use a
+ * larger underlying type and to change the Sequence Window size.
+ *
+ * Warning: two Lollipop counters can be compared only if they are of the same type (same underlying type, and same Sequence Window).
+ *
+ * References:
+ * [Perlman83] Perlman, R., "Fault-Tolerant Broadcast of Routing Information", North-Holland Computer Networks 7: pp. 395-405, DOI 10.1016/0376-5075(83)90034-X, 1983, <http://www.cs.illinois.edu/~pbg/courses/cs598fa09/readings/p83.pdf>.
+ *
+ * \tparam T \explicit The type being used for the counter.
+ */
+template <class T>
+class LollipopCounter
+{
+public:
+  /**
+   * Builds a Lollipop counter with a default initial value.
+   *
+   * The Sequence Window is set to the default value.
+   * The initial value is set to the maximum counter value minus the Sequence Window plus one.
+   */
+  LollipopCounter ()
+  {
+    NS_ABORT_MSG_UNLESS (std::is_unsigned<T>::value, "Lollipop counters must be defined on unsigned integer types");
+
+    uint16_t numberofDigits = std::numeric_limits<T>::digits;
+    m_sequenceWindow = 1 << (numberofDigits / 2);
+
+    m_value = (m_maxValue - m_sequenceWindow) + 1;
+  }
+
+  /**
+   * Builds a Lollipop counter with a specific initial value.
+   *
+   * The Sequence Window is set to the default value.
+   *
+   * \param val the initial value of the Lollipop Counter
+   * \tparam T \deduced The type being used for the counter.
+   */
+  LollipopCounter (T val)
+  {
+    uint16_t numberofDigits = std::numeric_limits<T>::digits;
+    m_sequenceWindow = 1 << (numberofDigits / 2);
+
+    m_value = val;
+  }
+
+  /**
+   * Assignment.
+   *
+   * \param [in] o Value to assign to this LollipopCounter.
+   * \returns This LollipopCounter.
+   */
+  inline LollipopCounter & operator = (const LollipopCounter & o)
+  {
+    m_value = o.m_value;
+    return *this;
+  }
+
+  /**
+   * Resets the counter to its initial value.
+   */
+  void Reset ()
+  {
+    m_value = (m_maxValue - m_sequenceWindow) + 1;
+  }
+
+  /**
+   * Set the Sequence Window Size and resets the counter.
+   *
+   * The sequence window is equal to 2^numberOfBits.
+   * The counter is reset to maxValue - m_sequenceWindow +1, where
+   * maxValue is the maximum number allowed by the underlying type.
+   *
+   * \param numberOfBits number of bits to use in the Sequence Window
+   */
+  void SetSequenceWindowSize (uint16_t numberOfBits)
+  {
+    uint16_t numberofDigits = std::numeric_limits<T>::digits;
+
+    NS_ABORT_MSG_IF (numberOfBits >= numberofDigits, "The size of the Sequence Window should be less than the counter size (which is " << +m_maxValue << ")");
+
+    m_sequenceWindow = 1 << numberOfBits;
+
+    m_value = (m_maxValue - m_sequenceWindow) + 1;
+  }
+
+  /**
+   * Checks if two counters are comparable (i.e., not desynchronized).
+   *
+   * If the absolute magnitude of difference of the two
+   * sequence counters is greater than Sequence Window, then a
+   * desynchronization has occurred and the two sequence
+   * numbers are not comparable.
+   *
+   * Sequence Window is equal to 2^N where N is (by default) half the number
+   * of digits of the underlying type.
+   *
+   * \returns true if the two counters are comparable.
+   */
+  bool IsComparable (const LollipopCounter &val) const
+  {
+    NS_ABORT_MSG_IF (m_sequenceWindow != val.m_sequenceWindow, "Can not compare two Lollipop Counters with different sequence windows");
+
+    if ( (m_value <= m_circularRegion && val.m_value <= m_circularRegion)
+         || (m_value > m_circularRegion && val.m_value > m_circularRegion) )
+      {
+        // They are desynchronized - comparison is impossible.
+        T absDiff = AbsoluteMagnitudeOfDifference (val);
+        if (absDiff > m_sequenceWindow)
+          {
+            return false;
+          }
+      }
+    return true;
+  }
+
+  /**
+   * Checks if a counter is in its starting region.
+   *
+   * \returns true if a counter is in its starting region.
+   */
+  bool IsInit () const
+  {
+    if ( m_value > m_circularRegion )
+      {
+        return true;
+      }
+    return false;
+  }
+
+  /**
+   * Arithmetic operator equal-to
+   * \param [in] lhs Left hand argument
+   * \param [in] rhs Right hand argument
+   * \return The result of the operator.
+   */
+  friend bool operator == (const LollipopCounter & lhs, const LollipopCounter & rhs)
+  {
+
+    NS_ABORT_MSG_IF (lhs.m_sequenceWindow != rhs.m_sequenceWindow, "Can not compare two Lollipop Counters with different sequence windows");
+
+    if (lhs.m_value == rhs.m_value)
+      {
+        return true;
+      }
+    return false;
+  }
+
+  /**
+   * Arithmetic operator greater-than
+   * \param [in] lhs Left hand argument
+   * \param [in] rhs Right hand argument
+   * \return The result of the operator.
+   */
+  friend bool operator > (const LollipopCounter & lhs, const LollipopCounter & rhs)
+  {
+    NS_ABORT_MSG_IF (lhs.m_sequenceWindow != rhs.m_sequenceWindow, "Can not compare two Lollipop Counters with different sequence windows");
+
+    if (lhs.m_value == rhs.m_value)
+      {
+        return false;
+      }
+
+    if ((lhs.m_value <= m_circularRegion && rhs.m_value <= m_circularRegion)
+        || (lhs.m_value > m_circularRegion && rhs.m_value > m_circularRegion) )
+      {
+        // both counters are in the same region
+
+        T absDiff = lhs.AbsoluteMagnitudeOfDifference (rhs);
+        if (absDiff > lhs.m_sequenceWindow)
+          {
+            // They are desynchronized - comparison is impossible.
+            // return false because we can not return anything else.
+            return false;
+          }
+
+        // They are synchronized - comparison according to RFC1982.
+        T serialRegion = ((m_circularRegion >> 1) + 1);
+        return (((lhs.m_value < rhs.m_value) && ((rhs.m_value - lhs.m_value) > serialRegion))
+                || ((lhs.m_value > rhs.m_value) && ((lhs.m_value - rhs.m_value) < serialRegion)) );
+      }
+
+    // One counter is in the "high" region and the other is in the in the "lower" region
+    bool lhsIsHigher;
+    T difference;
+
+    if (lhs.m_value > m_circularRegion && rhs.m_value <= m_circularRegion)
+      {
+        lhsIsHigher = true;
+        // this is guaranteed to be positive and between [1...m_lollipopMaxValue].
+        difference = lhs.m_value - rhs.m_value;
+      }
+    else
+      {
+        lhsIsHigher = false;
+        // this is guaranteed to be positive and between [1...m_lollipopMaxValue].
+        difference = rhs.m_value - lhs.m_value;
+      }
+
+    T distance = (m_maxValue - difference) + 1; // this is guaranteed to be positive and between [1...m_lollipopMaxValue].
+    if (distance > lhs.m_sequenceWindow)
+      {
+        if (lhsIsHigher)
+          {
+            return true;
+          }
+        else
+          {
+            return false;
+          }
+      }
+    else
+      {
+        if (lhsIsHigher)
+          {
+            return false;
+          }
+        else
+          {
+            return true;
+          }
+      }
+
+    // this should never be reached.
+    return false;
+  }
+
+  /**
+   * Arithmetic operator less-than
+   * \param [in] lhs Left hand argument
+   * \param [in] rhs Right hand argument
+   * \return The result of the operator.
+   */
+  friend bool operator < (const LollipopCounter & lhs, const LollipopCounter & rhs)
+  {
+    if (!lhs.IsComparable (rhs))
+      {
+        return false;
+      }
+
+    if (lhs > rhs)
+      {
+        return false;
+      }
+    else if (lhs == rhs)
+      {
+        return false;
+      }
+
+    return true;
+  }
+
+  /**
+   * Prefix increment operator
+   * \param [in] val LollipopCounter to be incremented
+   * \return The result of the Prefix increment.
+   */
+  friend LollipopCounter operator++ (LollipopCounter& val)   // prefix ++
+  {
+    val.m_value++;
+
+    if ( val.m_value == val.m_circularRegion + 1 )
+      {
+        val.m_value = 0;
+      }
+
+    return val;
+  }
+
+  /**
+   * Postfix increment operator
+   * \param [in] val LollipopCounter to be incremented
+   * \param [in] noop ignored argument (used to mark it as a postfix, blame c++).
+   * \return The result of the Postfix increment.
+   */
+  friend LollipopCounter operator++ (LollipopCounter& val, int noop)  // postfix ++
+  {
+    LollipopCounter ans = val;
+    ++(val);  // or just call operator++()
+    return ans;
+  }
+
+  /**
+   * Get the counter value.
+   *
+   * \return the counter value.
+   */
+  T GetValue () const
+  {
+    return m_value;
+  }
+
+  /**
+   * Output streamer for LollipopCounter.
+   *
+   * \param [in,out] os The output stream.
+   * \param [in] counter The LollipopCounter to print.
+   * \returns The stream.
+   */
+  friend std::ostream &
+  operator<< (std::ostream & os, LollipopCounter const & counter)
+  {
+    os << +counter.m_value;
+    return os;
+  }
+
+private:
+
+  /**
+   * Compute the Absolute Magnitude Of Difference between two counters.
+   *
+   * The Absolute Magnitude Of Difference is considered to
+   * be on a circular region, and it is represented by
+   * the smallest circular distance between two numbers.
+   *
+   *  Arithmetic operator.
+   *  \param [in] val Counter to compute the difference against
+   *  \return The result of the difference.
+   */
+  T AbsoluteMagnitudeOfDifference (LollipopCounter const & val) const
+  {
+    // useless because it is computed always on counters on their respective regions.
+    // Left (commented) for debugging purposes in case there is a code change.
+    // NS_ASSERT_MSG ((m_value <= m_circularRegion && val.m_value <= m_circularRegion) ||
+    //                (m_value > m_circularRegion && val.m_value > m_circularRegion),
+    //                "Absolute Magnitude Of Difference can be computed only on two values in the circular region " << +m_value << " - " << +val.m_value);
+
+    T absDiffDirect = std::max (m_value, val.m_value) - std::min (m_value, val.m_value);
+    T absDiffWrapped = (std::min (m_value, val.m_value) + m_circularRegion + 1) - std::max (m_value, val.m_value);
+    T absDiff = std::min (absDiffDirect, absDiffWrapped);
+    return absDiff;
+  }
+
+  T m_value;          //!< Value of the Lollipop Counter.
+  T m_sequenceWindow; //!< Sequence window used for comparing two counters.
+  static constexpr T m_maxValue = std::numeric_limits<T>::max ();  //!< Maximum value of the counter.
+  static constexpr T m_circularRegion = m_maxValue >> 1;           //!< Circular region of the counter.
+};
+
+/**
+ * \ingroup seq-counters
+ * 8 bit Lollipop Counter.
+ */
+typedef LollipopCounter<uint8_t> LollipopCounter8;
+/**
+ * \ingroup seq-counters
+ * 16 bit Lollipop Counter.
+ */
+typedef LollipopCounter<uint16_t> LollipopCounter16;
+
+} /* namespace ns3 */
+
+#endif /* LOLLIPOP_COUNTER_H */
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/network/utils/net-device-queue-interface.cc ns-3.32/src/network/utils/net-device-queue-interface.cc
--- ns-3.31/src/network/utils/net-device-queue-interface.cc	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/network/utils/net-device-queue-interface.cc	2020-10-06 15:35:43.000000000 -0700
@@ -29,6 +29,17 @@
 
 NS_LOG_COMPONENT_DEFINE ("NetDeviceQueueInterface");
 
+TypeId
+NetDeviceQueue::GetTypeId (void)
+{
+  static TypeId tid = TypeId ("ns3::NetDeviceQueue")
+    .SetParent<Object> ()
+    .SetGroupName("Network")
+    .AddConstructor<NetDeviceQueue> ()
+  ;
+  return tid;
+}
+
 NetDeviceQueue::NetDeviceQueue ()
   : m_stoppedByDevice (false),
     m_stoppedByQueueLimits (false),
@@ -170,6 +181,12 @@
     .SetParent<Object> ()
     .SetGroupName("Network")
     .AddConstructor<NetDeviceQueueInterface> ()
+    .AddAttribute ("TxQueuesType",
+                   "The type of transmission queues to be used",
+                   TypeId::ATTR_CONSTRUCT,
+                   TypeIdValue (NetDeviceQueue::GetTypeId ()),
+                   MakeTypeIdAccessor (&NetDeviceQueueInterface::SetTxQueuesType),
+                   MakeTypeIdChecker ())
     .AddAttribute ("NTxQueues", "The number of device transmission queues",
                    TypeId::ATTR_GET | TypeId::ATTR_CONSTRUCT,
                    UintegerValue (1),
@@ -229,6 +246,17 @@
 }
 
 void
+NetDeviceQueueInterface::SetTxQueuesType (TypeId type)
+{
+  NS_LOG_FUNCTION (this << type);
+
+  NS_ABORT_MSG_IF (!m_txQueuesVector.empty (), "Cannot call SetTxQueuesType after creating device queues");
+
+  m_txQueues = ObjectFactory ();
+  m_txQueues.SetTypeId (type);
+}
+
+void
 NetDeviceQueueInterface::SetNTxQueues (std::size_t numTxQueues)
 {
   NS_LOG_FUNCTION (this << numTxQueues);
@@ -239,7 +267,7 @@
   // create the netdevice queues
   for (std::size_t i = 0; i < numTxQueues; i++)
     {
-      m_txQueuesVector.push_back (Create<NetDeviceQueue> ());
+      m_txQueuesVector.push_back (m_txQueues.Create ()->GetObject<NetDeviceQueue> ());
     }
 }
 
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/network/utils/net-device-queue-interface.h ns-3.32/src/network/utils/net-device-queue-interface.h
--- ns-3.31/src/network/utils/net-device-queue-interface.h	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/network/utils/net-device-queue-interface.h	2020-10-06 15:35:43.000000000 -0700
@@ -27,6 +27,7 @@
 #include "ns3/ptr.h"
 #include "ns3/log.h"
 #include "ns3/net-device.h"
+#include "ns3/object-factory.h"
 
 namespace ns3 {
 
@@ -52,9 +53,15 @@
  *
  * This class roughly models the struct netdev_queue of Linux.
  */
-class NetDeviceQueue : public SimpleRefCount<NetDeviceQueue>
+class NetDeviceQueue : public Object
 {
 public:
+  /**
+   * \brief Get the type ID.
+   * \return the object TypeId
+   */
+  static TypeId GetTypeId (void);
+
   NetDeviceQueue ();
   virtual ~NetDeviceQueue();
 
@@ -84,7 +91,7 @@
    * Called by queue discs to enquire about the status of a given transmission queue.
    * This is the analogous to the netif_xmit_stopped function of the Linux kernel.
    */
-  bool IsStopped (void) const;
+  virtual bool IsStopped (void) const;
 
   /**
    * \brief Notify this NetDeviceQueue that the NetDeviceQueueInterface was
@@ -116,13 +123,13 @@
    * \brief Called by the netdevice to report the number of bytes queued to the device queue
    * \param bytes number of bytes queued to the device queue
    */
-  void NotifyQueuedBytes (uint32_t bytes);
+  virtual void NotifyQueuedBytes (uint32_t bytes);
 
   /**
    * \brief Called by the netdevice to report the number of bytes it is going to transmit
    * \param bytes number of bytes the device is going to transmit
    */
-  void NotifyTransmittedBytes (uint32_t bytes);
+  virtual void NotifyTransmittedBytes (uint32_t bytes);
 
   /**
    * \brief Reset queue limits state
@@ -252,6 +259,16 @@
   std::size_t GetNTxQueues (void) const;
 
   /**
+   * \brief Set the type of device transmission queues to create.
+   * \param type type of device transmission queues to create.
+   *
+   * This method is called when the TxQueuesType attribute is set to create
+   * the corresponding type of device transmission queues. It cannot be
+   * called again afterwards.
+   */
+  void SetTxQueuesType (TypeId type);
+
+  /**
    * \brief Set the number of device transmission queues to create.
    * \param numTxQueues number of device transmission queues to create.
    *
@@ -293,6 +310,7 @@
   virtual void NotifyNewAggregate (void);
 
 private:
+  ObjectFactory m_txQueues;   //!< Device transmission queues TypeId
   std::vector< Ptr<NetDeviceQueue> > m_txQueuesVector;   //!< Device transmission queues
   SelectQueueCallback m_selectQueueCallback;   //!< Select queue callback
 };
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/network/utils/packet-socket-server.cc ns-3.32/src/network/utils/packet-socket-server.cc
--- ns-3.31/src/network/utils/packet-socket-server.cc	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/network/utils/packet-socket-server.cc	2020-10-06 15:35:43.000000000 -0700
@@ -118,8 +118,8 @@
         {
           m_pktRx ++;
           m_bytesRx += packet->GetSize ();
-          NS_LOG_INFO ("At time " << Simulator::Now ().GetSeconds ()
-                       << "s packet sink received "
+          NS_LOG_INFO ("At time " << Simulator::Now ().As (Time::S)
+                       << " packet sink received "
                        << packet->GetSize () << " bytes from "
                        << PacketSocketAddress::ConvertFrom (from)
                        << " total Rx " << m_pktRx << " packets"
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/network/utils/queue-item.h ns-3.32/src/network/utils/queue-item.h
--- ns-3.31/src/network/utils/queue-item.h	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/network/utils/queue-item.h	2020-10-06 15:35:43.000000000 -0700
@@ -211,7 +211,7 @@
   /**
    * \brief Marks the packet as a substitute for dropping it, such as for Explicit Congestion Notification
    *
-   * \return true if the packet gets marked, false otherwise
+   * \return true if the packet is marked by this method or is already marked, false otherwise
    */
   virtual bool Mark (void) = 0;
 
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/network/utils/radiotap-header.cc ns-3.32/src/network/utils/radiotap-header.cc
--- ns-3.31/src/network/utils/radiotap-header.cc	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/network/utils/radiotap-header.cc	2020-10-06 15:35:43.000000000 -0700
@@ -725,7 +725,7 @@
     {
       m_hePad = ((2 - m_length % 2) % 2);
       m_present |= RADIOTAP_HE;
-      m_length += 12;
+      m_length += (12 + m_hePad);
     }
 
   NS_LOG_LOGIC (this << " m_length=" << m_length << " m_present=0x" << std::hex << m_present << std::dec);
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/network/utils/sequence-number.h ns-3.32/src/network/utils/sequence-number.h
--- ns-3.31/src/network/utils/sequence-number.h	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/network/utils/sequence-number.h	2020-10-06 15:35:43.000000000 -0700
@@ -29,6 +29,12 @@
 
 /**
  * \ingroup network
+ * \defgroup seq-counters Sequence Counter
+ * \brief "sequence number" classes
+ */
+
+/**
+ * \ingroup seq-counters
  * \brief Generic "sequence number" class
  *
  * This class can be used to handle sequence numbers.  In networking
@@ -467,17 +473,17 @@
 }
 
 /**
- * \ingroup network
+ * \ingroup seq-counters
  * 32 bit Sequence number.
  */
 typedef SequenceNumber<uint32_t, int32_t> SequenceNumber32;
 /**
- * \ingroup network
+ * \ingroup seq-counters
  * 16 bit Sequence number.
  */
 typedef SequenceNumber<uint16_t, int16_t> SequenceNumber16;
 /**
- * \ingroup network
+ * \ingroup seq-counters
  * 8 bit Sequence number.
  */
 typedef SequenceNumber<uint8_t, int8_t> SequenceNumber8;
@@ -485,7 +491,7 @@
 namespace TracedValueCallback {
 
 /**
- * \ingroup network
+ * \ingroup seq-counters
  * TracedValue callback signature for SequenceNumber32
  *
  * \param [in] oldValue original value of the traced variable
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/network/utils/simple-net-device.cc ns-3.32/src/network/utils/simple-net-device.cc
--- ns-3.31/src/network/utils/simple-net-device.cc	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/network/utils/simple-net-device.cc	2020-10-06 15:35:43.000000000 -0700
@@ -432,7 +432,6 @@
     {
       return false;
     }
-  Ptr<Packet> packet = p->Copy ();
 
   Mac48Address to = Mac48Address::ConvertFrom (dest);
   Mac48Address from = Mac48Address::ConvertFrom (source);
@@ -446,39 +445,50 @@
 
   if (m_queue->Enqueue (p))
     {
-      if (m_queue->GetNPackets () == 1 && !TransmitCompleteEvent.IsRunning ())
+      if (m_queue->GetNPackets () == 1 && !FinishTransmissionEvent.IsRunning ())
         {
-          p = m_queue->Dequeue ();
-          p->RemovePacketTag (tag);
-          Time txTime = Time (0);
-          if (m_bps > DataRate (0))
-            {
-              txTime = m_bps.CalculateBytesTxTime (packet->GetSize ());
-            }
-          m_channel->Send (p, protocolNumber, to, from, this);
-          TransmitCompleteEvent = Simulator::Schedule (txTime, &SimpleNetDevice::TransmitComplete, this);
+          StartTransmission ();
         }
       return true;
     }
 
-
-  m_channel->Send (packet, protocolNumber, to, from, this);
-  return true;
+  return false;
 }
 
-
 void
-SimpleNetDevice::TransmitComplete ()
+SimpleNetDevice::StartTransmission ()
 {
-  NS_LOG_FUNCTION (this);
-
   if (m_queue->GetNPackets () == 0)
     {
       return;
     }
-
+  NS_ASSERT_MSG (!FinishTransmissionEvent.IsRunning (),
+                 "Tried to transmit a packet while another transmission was in progress");
   Ptr<Packet> packet = m_queue->Dequeue ();
 
+  /**
+   * SimpleChannel will deliver the packet to the far end(s) of the link as soon as Send is called
+   * (or after its fixed delay, if one is configured). So we have to handle the rate of the link here,
+   * which we do by scheduling FinishTransmission (packetSize / linkRate) time in the future. While
+   * that event is running, the transmit path of this NetDevice is busy, so we can't send other packets. 
+   * 
+   * SimpleChannel doesn't have a locking mechanism, and doesn't check for collisions, so there's nothing
+   * we need to do with the channel until the transmission has "completed" from the perspective of this
+   * NetDevice. 
+   */
+  Time txTime = Time (0);
+  if (m_bps > DataRate (0))
+    {
+      txTime = m_bps.CalculateBytesTxTime (packet->GetSize ());
+    }
+  FinishTransmissionEvent = Simulator::Schedule (txTime, &SimpleNetDevice::FinishTransmission, this, packet);
+}
+
+void
+SimpleNetDevice::FinishTransmission (Ptr<Packet> packet)
+{
+  NS_LOG_FUNCTION (this);
+
   SimpleTag tag;
   packet->RemovePacketTag (tag);
 
@@ -488,15 +498,7 @@
 
   m_channel->Send (packet, proto, dst, src, this);
 
-  if (m_queue->GetNPackets ())
-    {
-      Time txTime = Time (0);
-      if (m_bps > DataRate (0))
-        {
-          txTime = m_bps.CalculateBytesTxTime (packet->GetSize ());
-        }
-      TransmitCompleteEvent = Simulator::Schedule (txTime, &SimpleNetDevice::TransmitComplete, this);
-    }
+  StartTransmission ();
 
   return;
 }
@@ -538,9 +540,9 @@
   m_node = 0;
   m_receiveErrorModel = 0;
   m_queue->Flush ();
-  if (TransmitCompleteEvent.IsRunning ())
+  if (FinishTransmissionEvent.IsRunning ())
     {
-      TransmitCompleteEvent.Cancel ();
+      FinishTransmissionEvent.Cancel ();
     }
   NetDevice::DoDispose ();
 }
